!------------------------------------------------------------------------------
      INTEGER    MSEC,MEX
      PARAMETER (MSEC=64)          ! nombre maximal de sections
      PARAMETER (MEX=251)          ! nombre max d'extensions de l'index
!
      CHARACTER*80 ISPEC,OSPEC     ! fichiers entree, sortie
      CHARACTER*80 DSPEC           ! fichier donnees
      INTEGER*4 IBLOC              ! bloc de l'obs courante
      INTEGER*4 CLUN               ! lun de l'observation courante
      INTEGER*4 MAXSEC             ! nb. max de sections
      INTEGER*4 ILUN               ! lun du fichier d'entree
      INTEGER*4 OLUN               ! lun du fichier sortie
      INTEGER*4 DLUN               ! lun fichier donnees
      INTEGER*4 DCODE              ! code du fichier data ext.
!
      INTEGER*4 INBLOC                      ! nbr. de blocs de l'obs. courante
      INTEGER*4 IDATA                       ! ad. donnees
      INTEGER*4 INSEC                       ! nb. de sections
      INTEGER*4 INEXT,ONEXT,DNEXT           ! proch bloc libre ds fichier
      INTEGER*4 IXNUM                       ! num. index de l'obs.
      INTEGER*4 INSPEC,ONSPEC,DNSPEC        ! long. nom de fichier
      INTEGER*4 IKBL                        ! offset actuel dans l'obs. (blocs)
      INTEGER*4 ICODE                       ! code d'id. lu
      INTEGER*4 CODE1,CODE2,CODE3           ! codes d'identification
      INTEGER*4 ISEC(MSEC)                  ! numeros des sections
      INTEGER*4 ILEN(MSEC)                  ! longueurs des sections
      INTEGER*4 IADD(MSEC)                  ! addresses des sections
      INTEGER*4 ILEX,OLEX,DLEX              ! longueur de l'extension d'index
      INTEGER*4 IMEX,OMEX,DMEX              ! nombre d'extensions de l'index
      INTEGER*4 IEX(MEX),OEX(MEX),DEX(MEX)  ! tableau des addr. des ext. (blocs)
      INTEGER*4 XLUN,XBL                    ! unite log. et bloc contenu ds xbuf
      INTEGER*4 IXNEXT,OXNEXT,DXNEXT        ! next avail. index entry
      INTEGER*4 INWORD                      ! nombre de mots ecrits ds l'obs.
      INTEGER*4 IDATAL                      ! nb. de mots des donnees
      INTEGER*4 OLD_IXNEXT                  ! Last known data in input file.
!
      INTEGER LENBUF
      PARAMETER (LENBUF=128)
      INTEGER*4 IBUF(LENBUF)       ! buffer de lecture/ecriture
      INTEGER*4 XBUF(LENBUF)       ! buffer de lec/ecr. d'index
      INTEGER*4 IH(9)              ! titre de l'observation
      INTEGER ICONVE               ! Do format conversion, input
      INTEGER OCONVE               ! Do format conversion, output
      INTEGER DCONVE               ! Do format conversion, data
      INTEGER NUMBER_TRYS          ! number of INTERVALs before timeout.
!
      LOGICAL MODIFY               ! the current observation is open
! for modification
      LOGICAL SHARE                ! the output file is shared
!
      REAL INTERVAL                ! Wait time for NEW_DATA
!
      COMMON/COM/ INTERVAL,                                             &
     &ISEC,ILEN,IADD,IH,                                                &
     &IBLOC,IBUF,IKBL,CLUN,ILUN,OLUN,                                   &
      ! NOTE: the ordering of these variables is COMPULSORY:
     &INEXT,ILEX,IMEX,IXNEXT,IEX,                                       &
     &ONEXT,OLEX,OMEX,OXNEXT,OEX,                                       &
     &MAXSEC,INSPEC,ONSPEC,DNSPEC,                                      &
     &XBUF,XLUN,XBL,                                                    &
     &OLD_IXNEXT,ICONVE,OCONVE,CODE1,CODE2,CODE3,                       &
     &MODIFY,SHARE,NUMBER_TRYS,                                         &
     &DLUN, DCODE, DCONVE,                                              &
     &DNEXT,DLEX,DMEX,DXNEXT,DEX   ! order COMPULSORY
      COMMON/CARCOM/ ISPEC,OSPEC,DSPEC
!
      EQUIVALENCE (IH(1),ICODE), (IH(2),INBLOC),(IH(3),INWORD),         &
     &(IH(5),IDATA),(IH(6),IDATAL),(IH(8),INSEC),                       &
     &(IH(9),IXNUM)
      INTEGER IEX1(123),IEX2(128)
      EQUIVALENCE (IEX1,IEX),(IEX2,IEX(124))
      INTEGER DEX1(123),DEX2(128)
      EQUIVALENCE (DEX1,DEX),(DEX2,DEX(124))
      INTEGER OEX1(123),OEX2(128)
      EQUIVALENCE (OEX1,OEX),(OEX2,OEX(124))
!
      SAVE /COM/, /CARCOM/
