# LaTeX2HTML 2002-2-1 (1.71)
# Associate images original text with physical files.


$key = q/^{1,3};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="22" HEIGHT="21" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img2.png"
 ALT="$^{1,3}$">|; 

$key = q/includegraphics[width=0.6textwidth,angle=-90]{class-hfs};LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="301" HEIGHT="2" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img35.png"
 ALT="\includegraphics[width=0.6\textwidth,angle=-90]{class-hfs}">|; 

$key = q/p_1;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="21" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img29.png"
 ALT="$p_1$">|; 

$key = q/p_2;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="21" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img20.png"
 ALT="$p_2$">|; 

$key = q/HPBW;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="67" HEIGHT="15" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img7.png"
 ALT="$HPBW$">|; 

$key = q/^+;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="16" HEIGHT="19" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img9.png"
 ALT="$^+$">|; 

$key = q/{displaymath}T_{{rm{ex}=T_{{rm{bg}+frac{F_{{rm{eff}}{B_{{rm{eff}}frac{p_1}{p_4}{displaymath};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="146" HEIGHT="46" BORDER="0"
 SRC="|."$dir".q|img32.png"
 ALT="\begin{displaymath}
T_{\rm ex} = T_{\rm bg} + \frac{F_{\rm eff}}{B_{\rm eff}} \frac{p_1}{p_4}
\end{displaymath}">|; 

$key = q/x;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="14" HEIGHT="14" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img6.png"
 ALT="$x$">|; 

$key = q/exp(-tau)ll1;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="103" HEIGHT="36" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img34.png"
 ALT="$\exp(-\tau)\ll 1$">|; 

$key = q/p_4;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="21" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img26.png"
 ALT="$p_4$">|; 

$key = q/S=sum{ensuremath{r_i}{;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="72" HEIGHT="33" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img13.png"
 ALT="$S=\sum\ensuremath{r_i}$">|; 

$key = q/v_i=0;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="50" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img21.png"
 ALT="$v_i=0$">|; 

$key = q/<40;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="40" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img39.png"
 ALT="$&lt; 40$">|; 

$key = q/i;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="10" HEIGHT="18" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img16.png"
 ALT="$i$">|; 

$key = q/10^6;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="29" HEIGHT="21" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img36.png"
 ALT="$10^6$">|; 

$key = q/{displaymath}tau_i(v)=tau_icdotexpleft[-4ln{2}left(frac{v-v_{0,i}}{p_3}right)^2right]{displaymath};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="272" HEIGHT="54" BORDER="0"
 SRC="|."$dir".q|img17.png"
 ALT="\begin{displaymath}
\tau_i(v) = \tau_i\cdot\exp\left[
-4\ln{2}\left(
\frac{v-v_{0,i}}{p_3}
\right)^2
\right]
\end{displaymath}">|; 

$key = q/{eqnarraystar}tau(v_i+p_2)&=&p_4cdotr_iqquad({rm{assumption,A4)displaystylesum_it)T_{{rm{ant}(v_i+p_2)&approx&p_1cdotr_i{eqnarraystar};MSF=1.6;LFS=11;TAGS=R;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="341" HEIGHT="139" BORDER="0"
 SRC="|."$dir".q|img25.png"
 ALT="\begin{eqnarray*}
\tau(v_i+p_2) &amp;=&amp; p_4 \cdot r_i\qquad (\rm assumption  A4)\\\\...
...p_4 r_i}\right)\\\\
T_{\rm ant}(v_i+p_2) &amp;\approx&amp; p_1 \cdot r_i
\end{eqnarray*}">|; 

$key = q/S=27;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="57" HEIGHT="15" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img15.png"
 ALT="$S=27$">|; 

$key = q/S;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="16" HEIGHT="15" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img27.png"
 ALT="$S$">|; 

$key = q/^{2};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="12" HEIGHT="21" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img3.png"
 ALT="$^{2}$">|; 

$key = q/{displaymath}T_{{rm{ant}(v)=frac{p_1}{p_4}left(1-e^{-tau(v)}right){displaymath};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="190" HEIGHT="42" BORDER="0"
 SRC="|."$dir".q|img24.png"
 ALT="\begin{displaymath}
T_{\rm ant}(v) = \frac{p_1}{p_4}
\left(
1 - e^{-\tau(v)}
\right)
\end{displaymath}">|; 

$key = q/^{rd};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="18" HEIGHT="20" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img43.png"
 ALT="$^{rd}$">|; 

$key = q/v_{0,i}=v_i+p_2;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="103" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img19.png"
 ALT="$v_{0,i}=v_i+p_2$">|; 

$key = q/_3;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="12" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img42.png"
 ALT="$_3$">|; 

$key = q/p_3;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="21" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img18.png"
 ALT="$p_3$">|; 

$key = q/{displaymath}T_{{rm{ant}(v)=T_A^*(v)=frac{B_{{rm{eff}}{F_{{rm{eff}}[T_{{rm{ex}-T_{{rm{bg}](1-e^{-tau(v)}){displaymath};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="343" HEIGHT="45" BORDER="0"
 SRC="|."$dir".q|img31.png"
 ALT="\begin{displaymath}
T_{\rm ant}(v) = T_A^*(v) = \frac{B_{\rm eff}}{F_{\rm eff}}
[T_{\rm ex} - T_{\rm bg}] (1-e^{-\tau(v)})
\end{displaymath}">|; 

$key = q/lambda<3;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="46" HEIGHT="34" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img30.png"
 ALT="$\lambda&lt;3$">|; 

$key = q/{displaymath}tau(v)=p_4displaystylesum_{i=1}^{N}r_icdotexpleft[-4ln{2}left(frac{v-v_i-p_2}{p_3}right)^2right]{displaymath};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="341" HEIGHT="58" BORDER="0"
 SRC="|."$dir".q|img22.png"
 ALT="\begin{displaymath}
\tau(v) = p_4 \displaystyle\sum_{i=1}^{N}
r_i\cdot\exp\left[
-4\ln{2}\left(
\frac{v-v_i-p_2}{p_3}
\right)^2
\right]
\end{displaymath}">|; 

$key = q/4'';MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="21" HEIGHT="20" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img37.png"
 ALT="$4''$">|; 

$key = q/^{-1};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="22" HEIGHT="21" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img41.png"
 ALT="$^{-1}$">|; 

$key = q/<30;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="40" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img38.png"
 ALT="$&lt; 30$">|; 

$key = q/N=7;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="52" HEIGHT="15" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img14.png"
 ALT="$N=7$">|; 

$key = q/_2;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="12" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img8.png"
 ALT="$_2$">|; 

$key = q/ensuremath{v_i};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="18" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img10.png"
 ALT="\ensuremath{v_i}">|; 

$key = q/0.1-30;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="65" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img33.png"
 ALT="$0.1-30$">|; 

$key = q/ensuremath{r_i};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="17" HEIGHT="31" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img11.png"
 ALT="\ensuremath{r_i}">|; 

$key = q/^{1};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="12" HEIGHT="21" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img1.png"
 ALT="$^{1}$">|; 

$key = q/N;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="20" HEIGHT="15" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img12.png"
 ALT="$N$">|; 

$key = q/backslash;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="13" HEIGHT="36" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img40.png"
 ALT="$\backslash$">|; 

$key = q/S=1;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="48" HEIGHT="15" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img28.png"
 ALT="$S=1$">|; 

$key = q/tau(v);MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="36" HEIGHT="36" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img23.png"
 ALT="$\tau(v)$">|; 

$key = q/w_i=DeltatDeltanuslashT_{{rm{sys}^2;MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="128" HEIGHT="39" ALIGN="MIDDLE" BORDER="0"
 SRC="|."$dir".q|img5.png"
 ALT="$w_i=\Delta t\Delta
\nu/T_{\rm sys}^2$">|; 

$key = q/^{3};MSF=1.6;LFS=11;AAT/;
$cached_env_img{$key} = q|<IMG
 WIDTH="12" HEIGHT="21" ALIGN="BOTTOM" BORDER="0"
 SRC="|."$dir".q|img4.png"
 ALT="$^{3}$">|; 

1;

