!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
module gildas_def
#if defined(BITS64)
  integer, parameter :: address_length=8
#else
  integer, parameter :: address_length=4
#endif
  integer, parameter :: varname_length=64
  integer, parameter :: filename_length=512
  integer, parameter :: commandline_length=2048
  !
  integer, parameter :: fatale=44            ! Fatal error code: '2C'X = 44
end module gildas_def
!
module gildas_interfaces
  !
  ! Duplicate of the public gsys_interfaces. Should be automatic in the
  ! future.
  interface sic_getvm
    !
    function sic_getvm4(nwords,address)
    use gildas_def
    integer(kind=4) :: sic_getvm4  ! Function value on return
    integer(kind=4),              intent(in)  :: nwords   ! As a 32-bit integer
    integer(kind=address_length), intent(out) :: address
    end function sic_getvm4
    !
    function sic_getvm8(nwords,address)
    use gildas_def
    integer(kind=4) :: sic_getvm8  ! Function value on return
    integer(kind=8),              intent(in)  :: nwords   ! As a 64-bit integer
    integer(kind=address_length), intent(out) :: address
    end function sic_getvm8
    !
  end interface
  !
  ! Duplicate of the public gwcs_interfaces. Should be automatic in the
  ! future.
  interface
    function projnam(iproj)
    character(len=13) :: projnam
    integer(kind=4), intent(in) :: iproj
    end function projnam
  end interface
  !
  ! Duplicate of the public sic_interfaces. Should be automatic in the
  ! future.
  interface
    function sic_exist(name)
    logical :: sic_exist
    character(len=*), intent(in) :: name
    end function sic_exist
  end interface
  !
end module gildas_interfaces
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
