
#include "gsys/cfc.h"

#define GPACK_SET_FCT_NAME(package) CFC_EXPORT_NAME(name2(package,_pack_set))
#define GPACK_LIB_NAME(package) "py"#package

#ifdef GAG_USE_PYTHON

#define GPACK_DEFINE_PYTHON_IMPORT(package)                                   \
                                                                              \
/**                                                                           \
 * Python import entry point                                                  \
 */                                                                           \
void name2(initpy,package)( )                                                 \
{                                                                             \
    void gpy_pack_import( );                                                  \
    void CFC_API GPACK_SET_FCT_NAME(package)( );                              \
                                                                              \
    gpy_pack_import( GPACK_SET_FCT_NAME(package), GPACK_LIB_NAME(package),    \
    "Please call welcome() method for module info");                          \
}

#else /* GAG_USE_PYTHON */

#define GPACK_DEFINE_PYTHON_IMPORT(package)

#endif /* GAG_USE_PYTHON */

#define GPACK_DEFINE_SIC_IMPORT(package)                                      \
                                                                              \
/**                                                                           \
 * SIC import entry point                                                     \
 */                                                                           \
void name2(package,_sic_import)( int debug, int *error)                       \
{                                                                             \
    void gpack_c_import( );                                                   \
    void CFC_API GPACK_SET_FCT_NAME(package)( );                              \
                                                                              \
    gpack_c_import( GPACK_SET_FCT_NAME(package), debug, error);               \
}

#define GPACK_DEFINE_IMPORT(package)                                          \
GPACK_DEFINE_SIC_IMPORT(package)                                              \
GPACK_DEFINE_PYTHON_IMPORT(package)

